
<p>Na prethodnoj stranici razmatrali smo sklop koji ostvaruje logičku funkciju čija je tablica istinitosti prikazana u nastavku.</p>

<table class="mlTableCC mlTableVR2">
<thead>
<tr><th>A</th><th>B</th><th>f</th></tr>
</thead>
<tbody>
<tr><td><code>0</code></td><td><code>0</code></td><td><code>0</code></td></tr>
<tr><td><code>0</code></td><td><code>1</code></td><td><code>1</code></td></tr>
<tr><td><code>1</code></td><td><code>0</code></td><td><code>1</code></td></tr>
<tr><td><code>1</code></td><td><code>1</code></td><td><code>1</code></td></tr>
</tbody>
</table>

<p>Naziv te logičke funkcije je <em>Uključivo-ILI</em> (engl. <i>inclusive-OR</i>); međutim, kako je to u praksi podrazumijevana operacija ILI (drugim riječima, ako ništa ne piše, onda piše "Uključivo"), koristi se kraći naziv <em>ILI</em> (engl. <i>OR</i>). Logička funkcija ILI na svojem izlazu daje vrijednost <code>1</code> čim je na barem jednom od ulaza postavljena logička vrijednost <code>1</code>.
Time se razlikuje od funkcije Isključivo-ILI koja isključuje mogućnost da su oba ulaza postavljena u <code>1</code>.</p>

<p>U tablici u nastavku prikazani su simboli kojima prikazujemo sklopove koji obavljaju funkciju ILI (tj. Uključivo-ILI).</p>

<table class="mlTableCC">
<tr><td><img src="@#file#(or-iec.svg)" alt="IEC OR simbol"></td><td><img src="@#file#(or-ansi.svg)" alt="ANSI OR simbol"></td></tr>
<tr><td>Simbol prema IEC-u</td><td>Simbol prema ANSI-ju</td></tr>
</table>

<p>Primjetite oznaku koja je navedena kod IEC-simbola. Zapamtite je ovako: izlaz je jedan kad je broj ulaza na koje je dovedena vrijednost jedan veći ili jednak jedan; "≥1" se odnosi na broj ulaza.</p>

<p>Funkcija ILI uz uobičajenu namjenu ("daj na izlazu 1 kad je barem jedan od ulaza 1") ima još jednu praktičnu primjenu koju ćemo opisati u nastavku. Pretpostavimo da želimo sklop koji se ponaša kako je specificirano na slici u nastavku.</p>

<figure style="text-align: center;">
<img src="@#file#(pustiILI-hr.svg)" alt="Sklop Propusti ili blokiraj." border="0">
<figcaption>Sklop koji ulazni signal propušta ili blokira.</figcaption>
</figure>

<p>Prikazani sklop ima dva ulaza: A i Control te jedan izlaz: Y. Kada je na upravljački ulaz Control dovedena vrijednost 0, sklop na svoj izlaz propušta vrijednost koja je dovedena na ulaz A: ako je A=0 tada će i Y biti 0; ako je A=1 tada će i Y biti 1.
Ako se na upravljački ulaz Control dovede vrijednost 1, tada sklop prestaje pratiti što se događa na ulazu A te na izlazu fiksno daje vrijednost 1.</p>

<p>Ovakav sklop htjet ćemo koristiti na putu nekog signala koji je potrebno ili dalje propustiti, ili ga blokirati. Primjerice, zamislite brojilo koje broji određen niz impulsa, ali želite da to radi samo kada je to dozvoljeno. Jedna mogućnost je niz impulsa
   provesti kroz ovakav sklop pa njegov izlaz odvesti na brojilo.</p>

<p>Ovo je lijepo ilustrirano na interaktivnoj simulaciji u nastavku. Prikazana shema se sastoji od sklopa ILI te generatora impulsa čiji je izlaz doveden na prvi ulaz sklopa ILI. Vrijednost
   koja se dovodi na drugi ulaz sklopa ILI (naš upravljački ulaz) može se mijenjati klikom na zasivljenu pločicu. Početno, na tom je ulazu vrijednost 0 pa očekujemo da signal koji se dovodi na prvi ulaz
   prolazi izravno na izlaz sklopa. Promatrajte jedno vrijeme rad sklopa i uočite da je to slučaj. Potom klikom na zasivljenu pločicu promijenite vrijednost koja se dovodi na drugi ulaz na 1. Gledajte sada kakva
   je veza između vrijednosti koja se dovodi na prvi ulaz i vrijednosti koja se pojavljuje na izlazu: uočite da sklop više ne prati prvi ulaz već mu je izlaz zaglavljen na vrijednosti <code>1</code>.</p>

<div style="text-align: center;">
<canvas id="myCanvas" width="320" height="160" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Leon Luttenberger</span>
</div>
<script>
    @#page-include#(Gate.js)
    @#page-include#(Utility.js)
    
    var canvas = document.getElementById("myCanvas");
    var context = canvas.getContext("2d");

    var orGate = new Gate(0, 0, function (a, b) {
        return a | b;
    }, "≥1");

    var gateHeight = 80;
    var gateWidth = 60;

    var inputABoxSize = 50;
    var inputBBoxSize = 30;

    var lineLengthA = 100;
    var lineLengthBX = 50;
    var lineLengthBY = 40;
    var lineLengthOutput = 60;

    var inputA;
    var inputB;

    var fontSize = 16;
    context.font = fontSize + "px Arial";

    var clockTimer = 500; //timer for the clock pulse

    draw();

    function draw() {

        context.lineWidth = 1;
        context.fillStyle = "black";
        context.strokeStyle = "black";

        context.clearRect(0, 0, canvas.width, canvas.height);
        orGate.draw(context, 160, 20, gateWidth, gateHeight);

        // Draw input A

        context.moveTo(orGate.inputAConnector.x, orGate.inputAConnector.y);
        context.lineTo(orGate.inputAConnector.x - lineLengthA, orGate.inputAConnector.y);
        context.stroke();

        inputA = new Rectangle(
                orGate.inputAConnector.x - lineLengthA - inputABoxSize,
                orGate.inputAConnector.y - inputABoxSize / 2,
                inputABoxSize,
                inputABoxSize
        );
        inputA.draw(context, 3);

        context.fillText(
                orGate.getInputA(),
                inputA.x + inputA.width + 10,
                orGate.inputAConnector.y - 10
        );
        context.fillText(
                orGate.getInputA(),
                orGate.inputAConnector.x - 20,
                orGate.inputAConnector.y - 10
        );

        drawImpulseClock(inputA, 10, 15);

        // Draw input B

        var xInputB = orGate.inputBConnector.x - lineLengthBX;
        var yInputB = orGate.inputBConnector.y + lineLengthBY;

        context.moveTo(orGate.inputBConnector.x, orGate.inputBConnector.y);
        context.lineTo(xInputB, orGate.inputBConnector.y);
        context.stroke();

        context.moveTo(xInputB, orGate.inputBConnector.y);
        context.lineTo(xInputB, yInputB);
        context.stroke();

        inputB = new Rectangle(
                xInputB - inputBBoxSize / 2,
                yInputB,
                inputBBoxSize,
                inputBBoxSize
        );
        inputB.draw(context, 3);

        context.fillStyle = "gray";
        context.fillRect(inputB.x, inputB.y, inputB.width, inputB.height);
        context.fillStyle = "black";

        context.fillText(
                orGate.getInputB(),
                inputB.x + inputB.width / 2 - fontSize / 3,
                inputB.y + inputB.height / 2 + fontSize / 3,
                inputBBoxSize
        );
        context.fillText(
                orGate.getInputB(),
                orGate.inputBConnector.x - 20,
                orGate.inputBConnector.y - 10
        );

        // Draw output

        context.moveTo(orGate.outputConnector.x, orGate.outputConnector.y);
        context.lineTo(orGate.outputConnector.x + lineLengthOutput, orGate.outputConnector.y);
        context.stroke();

        context.fillText(
                orGate.getOutput(),
                orGate.outputConnector.x + lineLengthOutput + 10,
                orGate.outputConnector.y + fontSize / 3
        );
    }

    function drawImpulseClock(box, horizontalMargin, verticalMargin) {
        var graphWidth = box.width - (2 * horizontalMargin);
        var step = graphWidth / 5;

        var xStart = box.x + horizontalMargin;

        var yBottom = box.y + box.height - verticalMargin;
        var yTop = box.y + verticalMargin;

        for (var i = 0; i < 5; i++) {
            var x = xStart + (i * step);
            var y = i % 2 != 0 ? yTop : yBottom;

            context.moveTo(x, y);
            context.lineTo(x + step, y);
            context.stroke();

            if (i != 0) {
                context.moveTo(x, yBottom);
                context.lineTo(x, yTop);
                context.stroke();
            }
        }
    }

    function animate() {
        orGate.setInputA(orGate.getInputA() == 0 ? 1: 0);

        draw();

        window.setTimeout(function () {
            animate();
        }, clockTimer);
    }

    window.setTimeout(function () {
        animate();
    }, clockTimer);

    canvas.addEventListener("mousedown", function (event) {
        var mouse = getMousePos(canvas, event);

        if (inputB.containsPoint(mouse.x, mouse.y)) {
            orGate.setInputB(orGate.getInputB() == 0 ? 1: 0);
            draw();
        }
    }, true);

</script>

<p>Sklop ILI može se izravno koristiti kao sklop za upravljanje propuštanjem signala. Zamislite da ulaz B koristimo kao upravljački ulaz, i pogledajte prethodnu tablicu u kojoj je opisana funkcija ILI. Pogledajte najprije prvi i treći redak; u njima je B=<code>0</code> i izlaz f prati ulaz A. Pogledajte sada drugi i četvrti redak; u njima je B=<code>1</code> i izlaz f fiksiran je na vrijednost <code>1</code>.</p>
